Index: /java/main/src/main/java/com/framsticks/running/ExternalProcess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 90)
@@ -15,19 +15,26 @@
 
 import com.framsticks.core.Entity;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Misc;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.dispatching.Thread;
 import com.framsticks.util.io.Encoding;
 
 @FramsClassAnnotation
-public class ExternalProcess extends Thread<ExternalProcess> implements Entity {
+public class ExternalProcess extends AbstractJoinable implements JoinableParent, Entity {
 	private static final Logger log = Logger.getLogger(ExternalProcess.class);
 
 	protected List<String> arguments = new ArrayList<>();
 	protected Process process;
-	protected ProcessBuilder builder = new ProcessBuilder();
-	protected Thread<ExternalProcess> readerThread;
+	protected final ProcessBuilder builder = new ProcessBuilder();
+	protected Thread<ExternalProcess> readerThread = new Thread<ExternalProcess>();
 
 	protected PrintWriter input;
@@ -37,4 +44,5 @@
 	protected final List<OutputListener> listeners = new LinkedList<>();
 
+	@AutoAppendAnnotation
 	public void addListener(OutputListener listener) {
 		synchronized (listeners) {
@@ -50,4 +58,5 @@
 		setName("process");
 		arguments.add(null);
+		builder.redirectErrorStream(true);
 	}
 
@@ -68,6 +77,5 @@
 	}
 
-	@Override
-	protected void routine() {
+	protected void readerTask() {
 
 		String line;
@@ -91,12 +99,11 @@
 			}
 			log.debug("process ended " + this);
-			process = null;
+			// process = null;
 		} catch (FramsticksException e) {
 			log.error("exception caught in process " + this, e);
 		}
 		interrupt();
+		// finish();
 	}
-
-
 
 	@ParamAnnotation
@@ -111,6 +118,5 @@
 
 	@Override
-	public void joinableStart() {
-		builder = new ProcessBuilder();
+	protected void joinableStart() {
 		log.debug("running process with arguments: " + arguments);
 		builder.command(arguments);
@@ -119,14 +125,23 @@
 			input = new PrintWriter(new OutputStreamWriter(process.getOutputStream(), Encoding.getDefaultCharset()));
 			output = new BufferedReader(new InputStreamReader(process.getInputStream(), Encoding.getDefaultCharset()));
+
 		} catch (IOException e) {
 			throw new FramsticksException().msg("failed to start process").cause(e);
 		}
-		super.joinableStart();
 
+		readerThread.dispatch(new RunAt<ExternalProcess>() {
+
+			@Override
+			public void run() {
+				readerTask();
+			}
+
+		});
+		Dispatching.use(readerThread, this);
 	}
 
 	@Override
 	public String toString() {
-		return super.toString() + "[" + Misc.returnNotNull(getCommand(), "?") + "]";
+		return getName() + "[" + Misc.returnNotNull(getCommand(), "?") + "]";
 	}
 
@@ -140,7 +155,39 @@
 	@Override
 	protected void joinableInterrupt() {
-		super.joinableInterrupt();
-		finish();
+		process.destroy();
+		Dispatching.drop(readerThread, this);
+		// finish();
 	}
 
+	@Override
+	@ParamAnnotation
+	public String getName() {
+		return readerThread.getName();
+	}
+
+	/**
+	 * @param name the name to set
+	 */
+	@ParamAnnotation
+	public void setName(String name) {
+		readerThread.setName(name);
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(readerThread);
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
+
+
 }
Index: /java/main/src/main/java/com/framsticks/running/FramsServer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/running/FramsServer.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/running/FramsServer.java	(revision 90)
@@ -8,4 +8,5 @@
 
 	protected Integer port;
+	protected String path;
 
 	/**
@@ -14,8 +15,8 @@
 	public FramsServer() {
 		super();
-		setCommand("/home/psniegowski/mgr/Framsticks32rc5/frams.linux");
-		setDirectory("/home/psniegowski/mgr/Framsticks32rc5");
+		setPath(System.getProperties().get("user.home") + "/opt/framsticks");
 		setName("frams");
 	}
+
 
 	/**
@@ -35,7 +36,26 @@
 	}
 
+	/**
+	 * @return the path
+	 */
+	@ParamAnnotation
+	public String getPath() {
+		return path;
+	}
+
+	/**
+	 * @param path the path to set
+	 */
+	@ParamAnnotation
+	public void setPath(String path) {
+		this.path = path;
+		setCommand(path + "/frams.linux");
+		setDirectory(path);
+	}
+
 	@Override
-	public void joinableStart() {
+	protected void joinableStart() {
 		if (port != null) {
+			arguments.add("-n");
 			arguments.add("-p" + port);
 		}
Index: /java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java
===================================================================
--- /java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java	(revision 90)
@@ -0,0 +1,18 @@
+package com.framsticks.running;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+
+@FramsClassAnnotation
+public class LoggingOutputListener implements OutputListener {
+	private static final Logger log =
+		Logger.getLogger(LoggingOutputListener.class);
+
+
+	@Override
+	public void onLineRead(String line) {
+		log.info(line);
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/util/AutoBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/AutoBuilder.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/util/AutoBuilder.java	(revision 90)
@@ -0,0 +1,9 @@
+package com.framsticks.util;
+
+import java.util.List;
+
+public interface AutoBuilder {
+
+	public List<Object> autoFinish();
+
+}
Index: /java/main/src/main/java/com/framsticks/util/DoubleMap.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/DoubleMap.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/DoubleMap.java	(revision 90)
@@ -50,3 +50,7 @@
 	}
 
+	public Map<K, V> getValuesById() {
+		return Collections.unmodifiableMap(byId);
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/util/Logging.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/Logging.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/Logging.java	(revision 90)
@@ -7,13 +7,13 @@
  */
 public abstract class Logging {
-    public static boolean log(Logger logger, String action, Object subject, Exception e) {
-        if (e != null) {
-            logger.error("failed to " + action + " " + subject + ": " + e);
-            return true;
-        }
-        if (logger.isDebugEnabled()) {
-            logger.debug("done: " + action + " " + subject);
-        }
-        return false;
-    }
+	public static boolean log(Logger logger, String action, Object subject, Exception e) {
+		if (e != null) {
+			logger.error("failed to " + action + " " + subject + ": ", e);
+			return true;
+		}
+		if (logger.isDebugEnabled()) {
+			logger.debug("done: " + action + " " + subject);
+		}
+		return false;
+	}
 }
Index: /java/main/src/main/java/com/framsticks/util/PeriodicTask.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/PeriodicTask.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/PeriodicTask.java	(revision 90)
@@ -16,10 +16,10 @@
 		this.period = period;
 		this.dispatcher = dispatcher;
-		dispatcher.invokeLater(this);
+		dispatcher.dispatch(this);
 	}
 
 
 	public void again() {
-		dispatcher.invokeLater(new Task<C>(System.currentTimeMillis() + period) {
+		dispatcher.dispatch(new Task<C>(System.currentTimeMillis() + period) {
 			@Override
 			public void run() {
Index: /java/main/src/main/java/com/framsticks/util/ResourceBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/ResourceBuilder.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/util/ResourceBuilder.java	(revision 90)
@@ -0,0 +1,41 @@
+package com.framsticks.util;
+
+import java.io.InputStream;
+
+import com.framsticks.params.annotations.ParamAnnotation;
+
+public abstract class ResourceBuilder<T> implements Builder<T> {
+
+	protected InputStream stream;
+
+	/**
+	 * @return the stream
+	 */
+	public InputStream getStream() {
+		return stream;
+	}
+
+	/**
+	 * @return the resource
+	 */
+	@ParamAnnotation
+	public String getResource() {
+		return resource;
+	}
+
+	/**
+	 * @param stream the stream to set
+	 */
+	public ResourceBuilder<T> stream(InputStream stream) {
+		this.stream = stream;
+		return this;
+	}
+
+	protected String resource;
+
+	@ParamAnnotation
+	public ResourceBuilder<T>  resource(String resource) {
+		this.resource = resource;
+		return stream(getClass().getResourceAsStream(resource));
+	}
+}
Index: /java/main/src/main/java/com/framsticks/util/UnimplementedException.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/UnimplementedException.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/util/UnimplementedException.java	(revision 90)
@@ -0,0 +1,6 @@
+package com.framsticks.util;
+
+@SuppressWarnings("serial")
+public class UnimplementedException extends FramsticksException {
+
+}
Index: /java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 90)
@@ -64,4 +64,5 @@
 				}
 			}
+			this.notifyAll();
 		}
 		report();
Index: /java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 90)
@@ -20,5 +20,5 @@
 
 	@Override
-	public final void invokeLater(RunAt<? extends C> runnable) {
+	public final void dispatch(RunAt<? extends C> runnable) {
 		runnable.run();
 	}
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java	(revision 90)
@@ -6,5 +6,5 @@
 public interface Dispatcher<C> {
 	public boolean isActive();
-	public void invokeLater(RunAt<? extends C> runnable);
+	public void dispatch(RunAt<? extends C> runnable);
 
 }
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 90)
@@ -15,15 +15,15 @@
 	}
 
-	public static <C> void invokeLaterOrNow(Dispatcher<C> dispatcher, RunAt<? extends C> runnable) {
+	public static <C> void dispatchIfNotActive(Dispatcher<C> dispatcher, RunAt<? extends C> runnable) {
 		if (dispatcher.isActive()) {
 			runnable.run();
 			return;
 		}
-		dispatcher.invokeLater(runnable);
+		dispatcher.dispatch(runnable);
 	}
 
 	//TODO RunAt StateFunctor
 	public static <C> void dispatchOk(Dispatcher<C> dispatcher, final StateFunctor stateFunctor) {
-		dispatcher.invokeLater(new RunAt<C>() {
+		dispatcher.dispatch(new RunAt<C>() {
 			@Override
 			public void run() {
@@ -39,15 +39,15 @@
 
 	public static <P, C> void invokeDispatch(Dispatcher<P> dispatcher, final Dispatcher<C> finalDispatcher, final RunAt<C> runnable) {
-		dispatcher.invokeLater(new RunAt<P>() {
+		dispatcher.dispatch(new RunAt<P>() {
 			@Override
 			public void run() {
-				finalDispatcher.invokeLater(runnable);
+				finalDispatcher.dispatch(runnable);
 			}
 		});
 	}
 
-	public static void sleep(int milliseconds) {
+	public static void sleep(double seconds) {
 		try {
-			java.lang.Thread.sleep(milliseconds, 0);
+			java.lang.Thread.sleep((long) (seconds * 1000));
 		} catch (InterruptedException e) {
 
@@ -58,5 +58,5 @@
 	public static void dispatcherGuardedInvoke(Joinable joinable, RunAt<?> runnable) {
 		if (joinable instanceof Dispatcher) {
-			invokeLaterOrNow(Dispatcher.class.cast(joinable), runnable);
+			dispatchIfNotActive(Dispatcher.class.cast(joinable), runnable);
 			return;
 		}
@@ -72,5 +72,4 @@
 		}
 	}
-
 
 	public static void drop(final Joinable joinable, final JoinableParent owner) {
@@ -106,5 +105,7 @@
 	public static void wait(Object object, long millis) {
 		try {
-			object.wait(millis);
+			synchronized (object) {
+				object.wait(millis);
+			}
 		} catch (InterruptedException e) {
 		}
@@ -112,5 +113,5 @@
 
 	public static void joinAbsolutely(Joinable joinable) {
-		log.info("joining absolutely " + joinable);
+		log.debug("joining absolutely " + joinable);
 		while (true) {
 			try {
@@ -120,11 +121,54 @@
 				// throw new FramsticksException().msg("failed to join").arg("dispatcher", dispatcher).cause(e);
 			}
-			log.info("waiting for " + joinable);
-			sleep(500);
+			log.debug("waiting for " + joinable);
+			wait(joinable, 500);
 		}
+	}
+
+	public interface Query<T> {
+		T get();
+	}
+
+	public static class QueryRunner<T, C> extends RunAt<C> {
+		protected final Query<T> query;
+		T result;
+		boolean ready = false;
+
+		/**
+		 * @param query
+		 */
+		public QueryRunner(Query<T> query) {
+			this.query = query;
+		}
+
+		@Override
+		public void run() {
+			result = query.get();
+			synchronized (this) {
+				ready = true;
+				this.notifyAll();
+			}
+		}
+
+		public T get() {
+			synchronized (this) {
+				while (!ready) {
+					try {
+						this.wait(100);
+					} catch (InterruptedException e) {
+					}
+				}
+			}
+			return result;
+		}
+	}
+
+	public static <T, C> T get(Dispatcher<C> dispatcher, Query<T> query) {
+		QueryRunner<T, C> runner = new QueryRunner<T, C>(query);
+		dispatcher.dispatch(runner);
+		return runner.get();
 	}
 
 
 
-
 }
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 90)
@@ -0,0 +1,69 @@
+package com.framsticks.util.dispatching;
+
+import org.apache.log4j.Logger;
+// import edu.umd.cs.findbugs.annotations.SuppressWarnings;
+import com.framsticks.util.dispatching.Dispatching;
+
+public class Monitor implements JoinableParent {
+	private static final Logger log =
+		Logger.getLogger(Monitor.class);
+
+	protected final Joinable joinable;
+
+	/**
+	 * @param joinable
+	 */
+	public Monitor(Joinable joinable) {
+		this.joinable = joinable;
+	}
+
+	public Monitor useFor(double seconds) {
+		Dispatching.sleep(seconds);
+		return this;
+	}
+
+	public Monitor waitFor() {
+		log.debug(this + " is waiting");
+		synchronized (this) {
+			while (joinable.getState().ordinal() < JoinableState.FINISHING.ordinal()) {
+				Dispatching.wait(this, 100);
+			}
+		}
+		log.debug(this + " ended waiting");
+		return this;
+	}
+
+	public Monitor use() {
+		log.debug(this + " is using");
+		Dispatching.use(joinable, this);
+		return this;
+	}
+
+	public Monitor drop() {
+		log.debug(this + " is droping");
+		Dispatching.drop(joinable, this);
+		return this;
+	}
+
+	public Monitor join() {
+		log.debug(this + " is joining");
+		Dispatching.joinAbsolutely(joinable);
+		log.debug(this + " is joined");
+		return this;
+	}
+
+	@Override
+	// @SuppressWarnings("NN_NAKED_NOTIFY")
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		synchronized (this) {
+			this.notify();
+		}
+		log.debug(this + " received notification about transition to " + state);
+	}
+
+	@Override
+	public String toString() {
+		return "monitor for " + joinable;
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java	(revision 90)
@@ -7,5 +7,5 @@
 
 	public RunAt(Dispatcher<? super C> dispatcher) {
-		dispatcher.invokeLater(this);
+		dispatcher.dispatch(this);
 	}
 }
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 90)
@@ -6,5 +6,4 @@
 import java.util.ListIterator;
 
-import javax.annotation.OverridingMethodsMustInvokeSuper;
 
 import com.framsticks.params.annotations.ParamAnnotation;
@@ -31,7 +30,4 @@
 	}
 
-	@OverridingMethodsMustInvokeSuper
-	protected void firstTask() {
-	}
 
 	public Thread(java.lang.Thread thread) {
@@ -51,5 +47,4 @@
 	protected void routine() {
 		log.debug("starting thread " + this);
-		firstTask();
 		while (!java.lang.Thread.interrupted()) {
 			Task<? extends C> task;
@@ -78,5 +73,5 @@
 				task.run();
 			} catch (Exception e) {
-				log.error("error in thread: " + e);
+				log.error("error in thread: ", e);
 			}
 		}
@@ -115,5 +110,5 @@
 
 	@Override
-	public void invokeLater(final RunAt<? extends C> runnable) {
+	public void dispatch(final RunAt<? extends C> runnable) {
 		if (!(runnable instanceof Task)) {
 			enqueueTask(new Task<C>() {
Index: /java/main/src/main/java/com/framsticks/util/dispatching/ThrowableHandler.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/ThrowableHandler.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/ThrowableHandler.java	(revision 90)
@@ -0,0 +1,5 @@
+package com.framsticks.util.dispatching;
+
+public interface ThrowableHandler<T extends Throwable> {
+	public void handle(T throwable);
+}
Index: /java/main/src/main/java/com/framsticks/util/lang/Containers.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/Containers.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/util/lang/Containers.java	(revision 90)
@@ -1,4 +1,5 @@
 package com.framsticks.util.lang;
 
+import java.util.ArrayList;
 import java.util.Collection;
 import java.util.Iterator;
@@ -8,4 +9,7 @@
 import org.apache.commons.collections.functors.NotPredicate;
 import org.apache.commons.collections.iterators.FilterIterator;
+
+import com.framsticks.util.Builder;
+import com.framsticks.util.FramsticksException;
 
 /**
@@ -37,3 +41,18 @@
 		return new IterableIterator<T>(new FilterIterator(c.iterator(), new NotPredicate(new InstanceofPredicate(type))));
 	}
+
+	public static <T> T getFromList(List<T> list, int number, String name, Object context) {
+		if (number < 0 || number >= list.size()) {
+			throw new FramsticksException().msg("invalid " + name + " number").arg("number", number).arg("in", context);
+		}
+		return list.get(number);
+	}
+
+	public static <T> List<T> build(List<? extends Builder<T>> builders) {
+		List<T> result = new ArrayList<T>();
+		for (Builder<T> builder : builders) {
+			result.add(builder.finish());
+		}
+		return result;
+	}
 }
Index: /java/main/src/test/java/com/framsticks/core/ObjectInstanceTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/core/ObjectInstanceTest.java	(revision 90)
+++ /java/main/src/test/java/com/framsticks/core/ObjectInstanceTest.java	(revision 90)
@@ -0,0 +1,88 @@
+package com.framsticks.core;
+
+import java.util.ArrayList;
+
+import org.testng.annotations.BeforeClass;
+// import org.testng.annotations.BeforeMethod;
+import org.testng.annotations.Test;
+
+import com.framsticks.model.Joint;
+import com.framsticks.model.Model;
+import com.framsticks.model.ModelBuilder;
+import com.framsticks.model.f0.Schema;
+import com.framsticks.model.f0.SchemaBuilder;
+import com.framsticks.test.TestConfiguration;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Monitor;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.ReflectionAccess;
+import com.framsticks.params.types.FloatParam;
+
+import static org.fest.assertions.Assertions.*;
+
+@Test
+public class ObjectInstanceTest extends TestConfiguration {
+
+	private Model model;
+	private Schema schema;
+	private ObjectInstance instance;
+	private Monitor monitor;
+
+	@BeforeClass
+	public void setUp() {
+		schema = new SchemaBuilder().stream(Schema.getDefaultDefinitionAsStream()).finish();
+		assertThat(schema.getFramsClasses().size()).isEqualTo(5);
+		assertThat(schema.getNeuroClasses().size()).isEqualTo(21);
+	}
+
+	@Test
+	public void loadModel() {
+		model = new ModelBuilder().schema(schema).stream(ObjectInstanceTest.class.getResourceAsStream("/parsers/f0_example.txt")).finish();
+
+		assertThat(model.getJoints().size()).isEqualTo(2);
+	}
+
+
+	@Test(dependsOnMethods = "loadModel", timeOut = 2000)
+	public void startInstance() {
+		instance = new ObjectInstance();
+		instance.getRegistry().takeAllFrom(schema.getRegistry());
+
+		instance.setRootObject(model);
+
+		monitor = new Monitor(instance);
+		monitor.use();
+
+		assertThat(Dispatching.get(instance, new Dispatching.Query<String>() {
+				@Override
+				public String get() {
+					return instance.getRootObject(Model.class).getParts().get(2).info;
+				}
+			})).isEqualTo("bla");
+
+		assertDispatch(instance, new RunAt<Instance>() {
+			@Override
+			public void run() {
+				assertThat(instance.getRootObject(Model.class).getNeuroDefinitions().get(2).details).isEqualTo("G");
+
+				Path path = instance.getPath("/");
+				assertThat(path.isResolved());
+				AccessInterface access = instance.bindAccess(path);
+				assertThat(access.get("se", Double.class)).isEqualTo(1.0);
+
+				assertThat(instance.bindAccess("/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getDef(Double.class)).isEqualTo(1.0);
+				assertThat(instance.bindAccess("/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getMax(Double.class)).isEqualTo(999.0);
+				assertThat(instance.bindAccess("/parts/2")).isInstanceOf(ReflectionAccess.class);
+				assertThat(instance.getPath("/neurodefs").getTopObject()).isInstanceOf(ArrayList.class);
+				assertThat(instance.getPath("/joints/1").getTopObject()).isInstanceOf(Joint.class);
+				assertThat(instance.bindAccess("/parts/2").get("i", String.class)).isEqualTo("bla");
+			}
+		});
+	}
+
+	@Test(dependsOnMethods = "startInstance", timeOut = 2000)
+	public void stoptInstance() {
+		monitor.useFor(1.0).drop().join();
+	}
+}
Index: /java/main/src/test/java/com/framsticks/gui/BrowserBaseTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/gui/BrowserBaseTest.java	(revision 90)
+++ /java/main/src/test/java/com/framsticks/gui/BrowserBaseTest.java	(revision 90)
@@ -0,0 +1,78 @@
+package com.framsticks.gui;
+
+import javax.swing.JFrame;
+
+import org.apache.log4j.Logger;
+import org.fest.swing.core.Robot;
+import org.fest.swing.edt.FailOnThreadViolationRepaintManager;
+import org.fest.swing.edt.GuiQuery;
+import org.fest.swing.fixture.FrameFixture;
+import org.fest.swing.fixture.JTreeFixture;
+import org.testng.annotations.AfterClass;
+import org.testng.annotations.BeforeClass;
+import org.testng.annotations.Test;
+
+import com.framsticks.test.TestConfiguration;
+import com.framsticks.util.dispatching.Monitor;
+
+import static org.fest.assertions.Assertions.assertThat;
+import static org.fest.swing.edt.GuiActionRunner.executeInEDT;
+import static org.fest.swing.core.BasicRobot.robotWithNewAwtHierarchy;
+import org.fest.swing.edt.GuiActionRunner;
+
+@Test
+public abstract class BrowserBaseTest extends TestConfiguration {
+
+	private static final Logger log = Logger.getLogger(BrowserTest.class);
+
+	protected Monitor monitor;
+	protected Browser browser;
+	protected static Robot robot;
+	protected FrameFixture frame;
+	protected JTreeFixture tree;
+
+	static {
+		FailOnThreadViolationRepaintManager.install();
+		assertThat(executeInEDT()).isTrue();
+
+		robot = robotWithNewAwtHierarchy();
+	}
+
+	@BeforeClass(timeOut = 5000)
+	public void setUp() {
+
+		configureBrowser();
+
+		monitor = new Monitor(browser);
+
+		monitor.use();
+
+		frame = new FrameFixture(robot,
+				GuiActionRunner.execute(new GuiQuery<JFrame>() {
+					@Override
+					protected JFrame executeInEDT() throws Throwable {
+						return browser.getMainFrame().getSwing();
+					}
+				}));
+
+		tree = frame.tree("tree");
+		log.debug("frame fixture done");
+	}
+
+	protected abstract void configureBrowser();
+
+	protected void clickAndExpandPath(String path) {
+		tree.clickPath(path).expandPath(path);
+		robot.waitForIdle();
+	}
+
+	protected void waitForIdle() {
+		robot.waitForIdle();
+	}
+
+	@AfterClass(timeOut = 5000)
+	public void tearDown() {
+		monitor.drop().join();
+	}
+
+}
Index: /java/main/src/test/java/com/framsticks/gui/BrowserTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/gui/BrowserTest.java	(revision 89)
+++ /java/main/src/test/java/com/framsticks/gui/BrowserTest.java	(revision 90)
@@ -1,75 +1,37 @@
 package com.framsticks.gui;
 
-import javax.swing.JFrame;
+import static org.fest.assertions.Assertions.assertThat;
+import static org.fest.swing.edt.GuiActionRunner.execute;
+
 
 import org.apache.log4j.Logger;
-import org.fest.swing.edt.FailOnThreadViolationRepaintManager;
-import org.fest.swing.edt.GuiActionRunner;
-import org.fest.swing.edt.GuiQuery;
 import org.fest.swing.edt.GuiTask;
-import org.fest.swing.fixture.FrameFixture;
-import org.fest.swing.fixture.JTreeFixture;
-// import static org.fest.swing.edt.GuiActionRunner.*;
-import org.testng.annotations.*;
+import org.testng.annotations.Test;
 
+import com.framsticks.model.ModelPackage;
 import com.framsticks.remote.RemoteInstance;
-import com.framsticks.test.TestConfiguration;
-import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.JoinableMonitor;
-// import com.framsticks.util.dispatching.Dispatching;
 
-import static org.fest.assertions.Assertions.*;
-import static org.fest.swing.core.BasicRobot.robotWithNewAwtHierarchy;
-import static org.fest.swing.edt.GuiActionRunner.*;
-import org.fest.swing.core.Robot;
+public class BrowserTest extends BrowserBaseTest {
 
-public class BrowserTest extends TestConfiguration {
 	private static final Logger log = Logger.getLogger(BrowserTest.class);
 
-	JoinableMonitor monitor;
-	Browser browser;
-	Robot robot;
-	FrameFixture frame;
+	RemoteInstance localhost;
 
-	@BeforeClass
-	public void setUp() {
-		FailOnThreadViolationRepaintManager.install();
-		assertThat(executeInEDT()).isTrue();
+	@Override
+	protected void configureBrowser() {
+		browser = new Browser();
 
-		robot = robotWithNewAwtHierarchy();
-
-		browser = new Browser();
-		monitor = new JoinableMonitor(browser);
-
-		RemoteInstance localhost = new RemoteInstance();
+		localhost = new RemoteInstance();
 		localhost.setName("localhost");
 		localhost.setAddress("localhost:9009");
+		localhost.usePackage(new ModelPackage());
 
 		browser.addInstance(localhost);
 
-		monitor.use();
-		// robot.waitForIdle();
-		frame = new FrameFixture(robot,
-				GuiActionRunner.execute(new GuiQuery<JFrame>() {
-					@Override
-					protected JFrame executeInEDT() throws Throwable {
-						return browser.getMainFrame().getSwing();
-					}
-				}));
-
-		log.info("frame fixture done");
-		// frame.show();
-		// log.info("frame fixture shown");
 	}
 
-	public void clickAndExpandPath(JTreeFixture tree, String path) {
-		tree.clickPath(path).expandPath(path);
-		robot.waitForIdle();
-	}
-
-	@Test
+	@Test(timeOut = 10000)
 	public void testShow() {
 		log.info("testing");
-		JTreeFixture tree = frame.tree("tree");
 		tree.clickRow(0).expandRow(0);
 		robot.waitForIdle();
@@ -81,54 +43,14 @@
 			@Override
 			protected void executeInEDT() throws Throwable {
-				assertThat(frame.panel("o Simulator").component().isVisible())
-						.isTrue();
+				assertThat(frame.panel("Simulator").component().isVisible()).isTrue();
 			}
 		});
 
-		clickAndExpandPath(tree, "localhost/simulator/genepools");
-		clickAndExpandPath(tree, "localhost/simulator/genepools/groups");
-		clickAndExpandPath(tree, "localhost/simulator/genepools/groups/Genotypes");
+		clickAndExpandPath("localhost/simulator/genepools");
+		clickAndExpandPath("localhost/simulator/genepools/groups");
+		clickAndExpandPath("localhost/simulator/genepools/groups/Genotypes");
+	}
 
 
 
-
-
-
-		// tree.clickPath("localhost/simulator/genepools/groups/Genotypes/genotypes");
-		// robot.waitForIdle();
-		// sleep(2);
-		// tree.expandPath("localhost/simulator/genepools/groups/Genotypes/genotypes");
-
-		// tree.expandRow(tree.component().getLeadSelectionRow() + 1);
-		// robot.waitForIdle();
-
-		// sleep(2);
-	}
-
-
-	@AfterClass
-	public void tearDown() {
-		log.info("before close");
-
-		monitor.drop();
-
-		Dispatching.joinAbsolutely(browser);
-		// frame.cleanUp();
-		// log.info("before close");
-		// browser.interrupt();
-
-		// try {
-		// 	// frame.close();
-		// } catch (Throwable t) {
-		// 	log.error("caught ", t);
-		// }
-		// log.info("after close");
-		// // frame.close();
-		// // frame.cleanUp();
-
-
-
-		// Dispatching.join(browser);
-	}
-
 }
